#include "mcp320x.h"
#include <iostream>
#include <stdio.h>
#include <sstream>
#include <string>

#define MCP3204_BUS	0
#define MCP3204_CE	0

int main( int argc, char *argv[] )
{
	MCP320X *adc;
	double v;
	int ch = 0;
	
	if( argc > 1 ) {
		std::istringstream is(argv[1]);
		is >> ch;
		if( ch >= MCP3204_CHANNELS ) {
			cerr << "Channel too large" << endl;
			return -1;
		}
	}
	
	try {
		adc = new MCP320X(MCP3204_BUS, MCP3204_CE);
		v = adc->getValue( ch );
	}
	catch( SPIException e ) {
		cerr << e.getString() << endl;
		delete(adc);
		return -1;
	}
	printf( "%4.3lfV\n", v );
	
	delete(adc);
	return 0;
}
